#!/usr/bin/env python

# Inspire by Conbagui tutorial found here: http://gimpnexuxtutorials.blogspot.com/2020/06/making-it-simple-text-tutorial.html

# author: Pocholo
# date: 6/12/20

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugin folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.

from gimpfu import *

def color_carvedin_text(customtext, font, fontsize, textcolor, backcolor,
																color1,
																color2,
																color3,
																color4,
																color5,
																color6,
																color7,
																color8):


	#Create a new image
	img = pdb.gimp_image_new(1, 1, RGB_IMAGE)

	disabled = pdb.gimp_image_undo_disable(img)
	pdb.gimp_context_push()
	
	#Create the text
	pdb.gimp_context_set_foreground(textcolor)
	layer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 50, 
										TRUE, fontsize, PIXELS, font)
	pdb.gimp_text_layer_set_letter_spacing(layer, 30)
	pdb.gimp_text_layer_set_line_spacing(layer, 10)
	pdb.gimp_text_layer_set_justification(layer, 2)
	
	#Resize text
	img.resize(layer.width, layer.height, 0, 0)
			
	#Make a selection on the text to create the layer colors
	pdb.gimp_image_select_item(img, 2, layer)
	pdb.plug_in_antialias(img, layer)
	
	#Create layer color 1
	layer1 = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Color 1", 100, LAYER_MODE_NORMAL)
	pdb.gimp_context_set_foreground(color1)
	pdb.gimp_image_add_layer(img, layer1, 0)
	pdb.gimp_layer_add_alpha(layer1)
	pdb.gimp_drawable_fill(layer1, FILL_TRANSPARENT)
	pdb.gimp_selection_grow(img, 5)
	pdb.plug_in_sel2path(img, layer1)
	vectors = pdb.gimp_image_get_active_vectors(img)
	pdb.gimp_vectors_to_selection(vectors, 2, TRUE, FALSE, 0, 0)
	pdb.gimp_drawable_edit_fill(layer1, FILL_FOREGROUND)
	
	
	#Create layer color 2
	layer2 = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Color 2", 100, LAYER_MODE_NORMAL)
	pdb.gimp_context_set_foreground(color2)
	pdb.gimp_image_add_layer(img, layer2, 0)
	pdb.gimp_layer_add_alpha(layer2)
	pdb.gimp_drawable_fill(layer2, FILL_TRANSPARENT)
	pdb.gimp_selection_grow(img, 5)
	pdb.plug_in_sel2path(img, layer2)
	vectors = pdb.gimp_image_get_active_vectors(img)
	pdb.gimp_vectors_to_selection(vectors, 2, TRUE, FALSE, 0, 0)
	pdb.gimp_drawable_edit_fill(layer2, FILL_FOREGROUND)
	
	
	#Create layer color 3
	layer3 = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Color 3", 100, LAYER_MODE_NORMAL)
	pdb.gimp_context_set_foreground(color3)
	pdb.gimp_image_add_layer(img, layer3, 0)
	pdb.gimp_layer_add_alpha(layer3)
	pdb.gimp_drawable_fill(layer3, FILL_TRANSPARENT)
	pdb.gimp_selection_grow(img, 5)
	pdb.plug_in_sel2path(img, layer3)
	vectors = pdb.gimp_image_get_active_vectors(img)
	pdb.gimp_vectors_to_selection(vectors, 2, TRUE, FALSE, 0, 0)
	pdb.gimp_drawable_edit_fill(layer3, FILL_FOREGROUND)
		
	
	#Create layer color 4
	layer4 = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Color 4", 100, LAYER_MODE_NORMAL)
	pdb.gimp_context_set_foreground(color4)
	pdb.gimp_image_add_layer(img, layer4, 0)
	pdb.gimp_layer_add_alpha(layer4)
	pdb.gimp_drawable_fill(layer4, FILL_TRANSPARENT)
	pdb.gimp_selection_grow(img, 5)
	pdb.plug_in_sel2path(img, layer4)
	vectors = pdb.gimp_image_get_active_vectors(img)
	pdb.gimp_vectors_to_selection(vectors, 2, TRUE, FALSE, 0, 0)
	pdb.gimp_drawable_edit_fill(layer4, FILL_FOREGROUND)
	
	
	#Create layer color 5
	layer5 = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Color 5", 100, LAYER_MODE_NORMAL)
	pdb.gimp_context_set_foreground(color5)
	pdb.gimp_image_add_layer(img, layer5, 0)
	pdb.gimp_layer_add_alpha(layer5)
	pdb.gimp_drawable_fill(layer5, FILL_TRANSPARENT)
	pdb.gimp_selection_grow(img, 5)
	pdb.plug_in_sel2path(img, layer5)
	vectors = pdb.gimp_image_get_active_vectors(img)
	pdb.gimp_vectors_to_selection(vectors, 2, TRUE, FALSE, 0, 0)
	pdb.gimp_drawable_edit_fill(layer5, FILL_FOREGROUND)
	
	
	#Create layer color 6
	layer6 = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Color 6", 100, LAYER_MODE_NORMAL)
	pdb.gimp_context_set_foreground(color6)
	pdb.gimp_image_add_layer(img, layer6, 0)
	pdb.gimp_layer_add_alpha(layer6)
	pdb.gimp_drawable_fill(layer6, FILL_TRANSPARENT)
	pdb.gimp_selection_grow(img, 5)
	pdb.plug_in_sel2path(img, layer6)
	vectors = pdb.gimp_image_get_active_vectors(img)
	pdb.gimp_vectors_to_selection(vectors, 2, TRUE, FALSE, 0, 0)
	pdb.gimp_drawable_edit_fill(layer6, FILL_FOREGROUND)
	
	
	#Create layer color 7
	layer7 = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Color 7", 100, LAYER_MODE_NORMAL)
	pdb.gimp_context_set_foreground(color7)
	pdb.gimp_image_add_layer(img, layer7, 0)
	pdb.gimp_layer_add_alpha(layer7)
	pdb.gimp_drawable_fill(layer7, FILL_TRANSPARENT)
	pdb.gimp_selection_grow(img, 5)
	pdb.plug_in_sel2path(img, layer7)
	vectors = pdb.gimp_image_get_active_vectors(img)
	pdb.gimp_vectors_to_selection(vectors, 2, TRUE, FALSE, 0, 0)
	pdb.gimp_drawable_edit_fill(layer7, FILL_FOREGROUND)
	
	
	#Create layer color 8
	layer8 = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Color 8", 100, LAYER_MODE_NORMAL)
	pdb.gimp_context_set_foreground(color8)
	pdb.gimp_image_add_layer(img, layer8, 0)
	pdb.gimp_layer_add_alpha(layer8)
	pdb.gimp_drawable_fill(layer8, FILL_TRANSPARENT)
	pdb.gimp_selection_grow(img, 5)
	pdb.plug_in_sel2path(img, layer8)
	vectors = pdb.gimp_image_get_active_vectors(img)
	pdb.gimp_vectors_to_selection(vectors, 2, TRUE, FALSE, 0, 0)
	pdb.gimp_drawable_edit_fill(layer8, FILL_FOREGROUND)
	pdb.script_fu_reverse_layers(img, layer8)
	pdb.gimp_selection_none(img)
	
	#Clear the center of each color layer text

	#Create a selection on the text
	pdb.gimp_image_set_active_layer(img, layer1)
	pdb.gimp_image_select_item(img, 2, layer1)
	
	#Layer 2
	pdb.gimp_image_set_active_layer(img, layer1)
	pdb.gimp_edit_clear(layer1)
	
	
	#Layer 2
	pdb.gimp_image_set_active_layer(img, layer2)
	pdb.gimp_edit_clear(layer2)
	
	#Layer 3
	pdb.gimp_image_set_active_layer(img, layer3)
	pdb.gimp_edit_clear(layer3)
	
	#Layer 4
	pdb.gimp_image_set_active_layer(img, layer4)
	pdb.gimp_edit_clear(layer4)
	
	#Layer 5
	pdb.gimp_image_set_active_layer(img, layer5)
	pdb.gimp_edit_clear(layer5)
	
	#Layer 6
	pdb.gimp_image_set_active_layer(img, layer6)
	pdb.gimp_edit_clear(layer6)
	
	#Layer 7
	pdb.gimp_image_set_active_layer(img, layer7)
	pdb.gimp_edit_clear(layer7)
	
	#Layer 8
	pdb.gimp_image_set_active_layer(img, layer8)
	pdb.gimp_edit_clear(layer8)
	
	
	pdb.gimp_image_lower_item_to_bottom(img, layer)
	
	
	whitelayer = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "White", 100, LAYER_MODE_OVERLAY)
	pdb.gimp_image_add_layer(img, whitelayer, 9)
	pdb.gimp_layer_add_alpha(whitelayer)
	pdb.gimp_drawable_fill(whitelayer, FILL_TRANSPARENT)
	pdb.gimp_drawable_edit_fill(whitelayer, FILL_WHITE)
	pdb.gimp_selection_none(img)
	
	
	#Create the inner shadow
	pdb.python_layer_fx_inner_shadow(img, layer, (0, 0, 0),
													  85,   #opacity
													  5,    #0 for Linear contour
													  0,    #noise
													  3,     #mode 19 for softlight 3 for multiply
													  1,     #source 0 for center 1 for edge check this one
													  0,     #choke
													  18,    #size
													  120,   #offset-angle
													  21,    #offset-distance
													  FALSE) #merge with layer
	pdb.gimp_item_set_visible(layer, FALSE)
	
	#Create background
	backlayer = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, backlayer, 11)
	pdb.gimp_context_set_background((22, 22, 22))
	pdb.gimp_drawable_fill(backlayer, FILL_BACKGROUND)
	pdb.plug_in_gmic_qt(img, backlayer, 1, 0, 
		"-v - -fx_scanlines 50,5,2,145,0,0,0,0")
		
		
	pdb.gimp_selection_none(img)
	
	pdb.gimp_item_set_visible(backlayer, TRUE)

	pdb.gimp_context_pop()
	enabled = pdb.gimp_image_undo_enable(img)
		
	pdb.gimp_display_new(img)
	
register(
	"color_carvedin_text",
	"Creates a carvedin text",
	"Creates a carvedin text",
	"Pocholo",
	"Pocholo",
	"2020",
	"Color carved in text",
	"",
[
	(PF_STRING, "customtext", "Text string", 'AWE'),
    (PF_FONT, "font", "Font face", "Arial"),
	(PF_SPINNER, "fontsize", "Font size", 200, (200, 300, 1)),
    (PF_COLOR, "textcolor", "Text color", "Black"),
	(PF_COLOR, "backcolor", "Background color", (22, 22, 22)),
	(PF_COLOR, "color1", "Create color 1", (128,0,128)),
	(PF_COLOR, "color2", "Create color 2", (255,165,0)),
	(PF_COLOR, "color3", "Create color 3", (0,255,0)),
	(PF_COLOR, "color4", "Create color 4", (0,255,255)),
	(PF_COLOR, "color5", "Create color 5", (255,0,255)),
	(PF_COLOR, "color6", "Create color 6", (0,0,255)),
	(PF_COLOR, "color7", "Create color 7", (255,255,0)),
	(PF_COLOR, "color8", "Create color 8", (255, 0, 0)),
],
[],
color_carvedin_text, menu="<Image>/Python-Fu/Color carved in text")
main()